#ifndef __IMAGE_H__
#define __IMAGE_H__

#include <sys/ksys.h>
#include <string>
#include <fstream>

#include "base.hpp"
#include "filesystem.hpp"

namespace KolibriLib
{
    namespace Image
    {
        /// @brief Класс для работы с изображениями
        class img
        {
        private:
            rgb_t *_d;
            point _size;

        public:
            img(std::string Path);
            ~img();

            /// @brief Загрузить изображение из файла
            /// @param Path Путь до файла с изображением
            /// @return true если удачно, false если неудачно
            bool LoadImage(std::string Path);

            /// @briefВывести изображение
            /// @param coord координаты
            /// @param size
            /// @warning Функция пока что очень медленная, может быть когданибудь позже от=птимизирую...
            void DrawImage(point coord = {0, 0}, point size = {0, 0});
        };

        img::img(std::string Path)
        {
            LoadImage(Path);
            _d = (rgb_t *)malloc(sizeof(rgb_t));
        }

        img::~img()
        {
            free(_d);
        }

        bool img::LoadImage(std::string Path)
        {
            bool extcode;
            if (filesystem::Exist(Path)) // Если файл с изображением существует
            {
                std::string Type;
                std::ifstream img;

                {
                    unsigned i = Path.length();

                    while (Path[i] != '.')
                    {
                        Type.push_back(Path[i]);
                        i--;
                    }
                }

                if (Type == "png")
                {
                }
                else if (Type == "jpeg")
                {
                    /* code */
                }
                else
                {
                    extcode = false;
                }

                img.close();
            }
            else
            {
                return extcode = false;
            }
            return extcode;
        }

        void img::DrawImage(point coord, point size)
        {
            if (size.x == 0 && size.y == 0)
            {
                size = _size;
            }

            _ksys_draw_bitmap(_d, coord.x, coord.y, size.x, size.y);
        }

    } // namespace Image
    
}
#endif // __IMAGE_H__