#include "graphic.hpp"

void KolibriLib::graphic::DrawCircleFill(point coord, unsigned Radius, ksys_color_t color)
{
    DrawCircle(coord, Radius, color);
    unsigned b = Radius * cos(90 + 45);
    unsigned c = Radius * sin(90 + 45);
    point n = {coord.x + b, coord.y + c};
    DrawRectangleFill(n, {(coord.x - n.x) * 2, c * 2}, color);
    for (unsigned i = Radius; i > (Radius - (coord.x - n.x)); i--) // Дозакрашивание пробелов между квадратом и границами груга
    {
        DrawCircle(coord, i, NULL, color);
    }
}

void KolibriLib::graphic::DrawPoint(const point &position, const unsigned &Radius, const ksys_color_t &color, bool fill)
{
            if(Radius < 3)    //Если радиус меньше 3 пикселей, то не смысла его закрашивать
            {
                fill = false;
            }
            if (fill)
            {
                DrawCircleFill(position, Radius, color);
            }
            else
            {
                DrawCircle(position, Radius, color);
                if(Radius < 3)
                {
                    DrawPixel(position, color);
                }
            }
}

void KolibriLib::graphic::DrawRectangleLines(point a, point b, ksys_color_t color)
{
    DrawLine(a, {b.x, a.y}, color);
    DrawLine(a, {a.x, b.y}, color);
    DrawLine({b.x, a.y}, b, color);
    DrawLine({a.x, b.y}, b, color);
}

void KolibriLib::graphic::DrawTriangle(point a, point b, point c, ksys_color_t color)
{
    DrawLine(a, b, color);
    DrawLine(a, c, color);
    DrawLine(b, c, color);
}