/*
    Файл с константами и малыми струтурами, которые используются везде
*/
#ifndef __SMALL_H__
#define __SMALL_H__

#include <string>

namespace KolibriLib
{
    /// @brief Сообщение всем функциям что нужно завершать работу
    bool EXIT = false;
    /// @brief Код ошибки
    /// @paragraph int main(){/*...*/ return EXITCODE; }
    /// @paragraph Эта библиотека считает что EXITCODE = 0 - это завершение работы без ошибки
    int EXITCODE = 0;

    const std::string ConfigurationDir = "/kolibrios/etc/"; 

    const std::string ImgDir = ConfigurationDir + "images/";

    const std::string CursorsDir = ConfigurationDir + "cursors/";   //Предпологается что в этой папке лежат файлы, они заранее приготовленны

    /// \brief Просто точка
    struct point
    {
        unsigned x;
        unsigned y;
    };
} // namespace KolibriLib


#endif // __SMALL_H__